#ObserverSwarm.py
import ModelSwarmStep
import ActionGroup


class ObserverSwarm:

    # create objects
    def buildObjects(self):
        self.nBugs = input("How many bugs? ")
        self.worldXSize= input("X Size of the world? ")
        self.worldYSize= input("Y Size of the world? ")
        self.nCycles = input("How many cycles? (0 = exit) ")

        self.modelSwarm = ModelSwarmStep.ModelSwarm(self.nBugs,
                                         self.worldXSize, self.worldYSize)
        self.modelSwarm.buildObjects()

    # create schedule
    def buildActions(self):
        
        self.modelSwarm.buildActions()

        self.actionGroup1 = ActionGroup.ActionGroup ("observerTime")
        def do1(self, nCycle):
            print "Observer time = ", nCycle
        self.actionGroup1.do = do1 # do is a variable linking a method

        self.actionGroupList = ["step", "observerTime"]
                
    # run
    def run(self):

        for n in range(self.nCycles):

            for s in self.actionGroupList:

                if s == "step":
                    self.modelSwarm.step(n)

                if s == "observerTime":
                    self.actionGroup1.do(self, n)

        print
        print "Simulation stopped after ", self.nCycles, " cycles"
